'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var PATH = _interopDefault(require('path'));

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

var classCallCheck = _classCallCheck;

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

var createClass = _createClass;

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var _typeof_1 = createCommonjsModule(function (module) {
function _typeof2(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof2 = function _typeof2(obj) { return typeof obj; }; } else { _typeof2 = function _typeof2(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof2(obj); }

function _typeof(obj) {
  if (typeof Symbol === "function" && _typeof2(Symbol.iterator) === "symbol") {
    module.exports = _typeof = function _typeof(obj) {
      return _typeof2(obj);
    };
  } else {
    module.exports = _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof2(obj);
    };
  }

  return _typeof(obj);
}

module.exports = _typeof;
});

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

var assertThisInitialized = _assertThisInitialized;

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof_1(call) === "object" || typeof call === "function")) {
    return call;
  }

  return assertThisInitialized(self);
}

var possibleConstructorReturn = _possibleConstructorReturn;

var getPrototypeOf = createCommonjsModule(function (module) {
function _getPrototypeOf(o) {
  module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

module.exports = _getPrototypeOf;
});

var setPrototypeOf = createCommonjsModule(function (module) {
function _setPrototypeOf(o, p) {
  module.exports = _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

module.exports = _setPrototypeOf;
});

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) setPrototypeOf(subClass, superClass);
}

var inherits = _inherits;

var construct = createCommonjsModule(function (module) {
function isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (isNativeReflectConstruct()) {
    module.exports = _construct = Reflect.construct;
  } else {
    module.exports = _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

module.exports = _construct;
});

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

var objectWithoutPropertiesLoose = _objectWithoutPropertiesLoose;

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = objectWithoutPropertiesLoose(source, excluded);
  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

var objectWithoutProperties = _objectWithoutProperties;

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

var arrayWithHoles = _arrayWithHoles;

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

var iterableToArrayLimit = _iterableToArrayLimit;

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

var nonIterableRest = _nonIterableRest;

function _slicedToArray(arr, i) {
  return arrayWithHoles(arr) || iterableToArrayLimit(arr, i) || nonIterableRest();
}

var slicedToArray = _slicedToArray;

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
      arr2[i] = arr[i];
    }

    return arr2;
  }
}

var arrayWithoutHoles = _arrayWithoutHoles;

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

var iterableToArray = _iterableToArray;

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

var nonIterableSpread = _nonIterableSpread;

function _toConsumableArray(arr) {
  return arrayWithoutHoles(arr) || iterableToArray(arr) || nonIterableSpread();
}

var toConsumableArray = _toConsumableArray;

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

var defineProperty = _defineProperty;

var nativePromise = Promise;
function mapSerie(arr, callback) {
  var PromiseInterface = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : nativePromise;
  var PromiseFactory = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : nativePromise;
  return arr.reduce(function (promise, item) {
    return promise.then(function (result) {
      var promise = callback(item);

      if (!(promise instanceof PromiseInterface)) {
        promise = PromiseFactory.resolve(promise);
      }

      return promise.then(Array.prototype.concat.bind(result));
    });
  }, PromiseFactory.resolve([]));
}

var Var = function Var() {
  classCallCheck(this, Var);
};

var Factory =
/*#__PURE__*/
function (_Var) {
  inherits(Factory, _Var);

  function Factory(callback) {
    var _this;

    var shareInstances = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    classCallCheck(this, Factory);

    _this = possibleConstructorReturn(this, getPrototypeOf(Factory).call(this));
    _this.CallbackDef = callback;
    _this.shareInstances = shareInstances;
    return _this;
  }

  return Factory;
}(Var);

var ValueFactory =
/*#__PURE__*/
function (_Factory) {
  inherits(ValueFactory, _Factory);

  function ValueFactory() {
    classCallCheck(this, ValueFactory);

    return possibleConstructorReturn(this, getPrototypeOf(ValueFactory).apply(this, arguments));
  }

  createClass(ValueFactory, [{
    key: "callback",
    value: function callback(shareInstances) {
      if (this.shareInstances) {
        return this.CallbackDef(shareInstances);
      }

      return this.CallbackDef();
    }
  }]);

  return ValueFactory;
}(Factory);

var ClassFactory =
/*#__PURE__*/
function (_Factory) {
  inherits(ClassFactory, _Factory);

  function ClassFactory() {
    classCallCheck(this, ClassFactory);

    return possibleConstructorReturn(this, getPrototypeOf(ClassFactory).apply(this, arguments));
  }

  createClass(ClassFactory, [{
    key: "callback",
    value: function callback(shareInstances) {
      if (this.shareInstances) {
        return new this.CallbackDef(shareInstances);
      }

      return new this.CallbackDef();
    }
  }]);

  return ClassFactory;
}(Factory);

var Value =
/*#__PURE__*/
function (_Var) {
  inherits(Value, _Var);

  function Value(value) {
    var _this;

    classCallCheck(this, Value);

    _this = possibleConstructorReturn(this, getPrototypeOf(Value).call(this));
    _this.value = value;
    return _this;
  }

  createClass(Value, [{
    key: "getValue",
    value: function getValue() {
      return this.value;
    }
  }]);

  return Value;
}(Var);

var Interface =
/*#__PURE__*/
function (_Var) {
  inherits(Interface, _Var);

  function Interface(name) {
    var _this;

    classCallCheck(this, Interface);

    _this = possibleConstructorReturn(this, getPrototypeOf(Interface).call(this));
    _this.name = name;
    return _this;
  }

  createClass(Interface, [{
    key: "getName",
    value: function getName() {
      return this.name;
    }
  }]);

  return Interface;
}(Var);

var InterfaceClass =
/*#__PURE__*/
function (_Interface) {
  inherits(InterfaceClass, _Interface);

  function InterfaceClass(name, interfaceClass) {
    var _this;

    classCallCheck(this, InterfaceClass);

    _this = possibleConstructorReturn(this, getPrototypeOf(InterfaceClass).call(this, name));
    _this.interfaceClass = interfaceClass;
    return _this;
  }

  createClass(InterfaceClass, [{
    key: "getInterfaceClass",
    value: function getInterfaceClass() {
      return this.interfaceClass;
    }
  }]);

  return InterfaceClass;
}(Interface);

var Require =
/*#__PURE__*/
function (_Var) {
  inherits(Require, _Var);

  function Require(dep) {
    var _this;

    var requires = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

    classCallCheck(this, Require);

    _this = possibleConstructorReturn(this, getPrototypeOf(Require).call(this));
    _this.dep = PATH.normalize(dep);
    _this.requires = requires;
    return _this;
  }

  createClass(Require, [{
    key: "require",
    value: function require() {
      return this.requires[this.dep];
    }
  }]);

  return Require;
}(Var);

var SharedInstance =
/*#__PURE__*/
function () {
  function SharedInstance(interfaceName, container) {
    classCallCheck(this, SharedInstance);

    this.container = container;
    this.interfaceName = interfaceName;
  }

  createClass(SharedInstance, [{
    key: "get",
    value: function get(shareInstances) {
      var stack = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

      if (!this.instance) {
        this.instance = this.container.get(this.interfaceName, undefined, shareInstances, stack);
      }

      return this.instance;
    }
  }]);

  return SharedInstance;
}();

var ClassDef =
/*#__PURE__*/
function () {
  function ClassDef(callback) {
    classCallCheck(this, ClassDef);

    this.callback = callback;
  }

  createClass(ClassDef, [{
    key: "getClassDef",
    value: function getClassDef() {
      return this.callback();
    }
  }]);

  return ClassDef;
}();

var Dependency =
/*#__PURE__*/
function () {
  function Dependency(dep) {
    classCallCheck(this, Dependency);

    this.dep = dep;
  }

  createClass(Dependency, [{
    key: "getDependency",
    value: function getDependency() {
      return this.dep;
    }
  }]);

  return Dependency;
}();

function makeContainerApi(container) {
  var di = function di() {
    return container.decorator.apply(container, arguments);
  };

  di.container = container;
  di.get = container.get.bind(container);
  di.exists = container.exists.bind(container);
  di.factory = container.factory.bind(container);
  di.classFactory = container.classFactory.bind(container);
  di.valueFactory = container.valueFactory.bind(container);
  di.value = container.value.bind(container);
  di.interface = container.interface.bind(container);
  di.require = container.require.bind(container);
  di.addRule = container.addRule.bind(container);
  di.addRules = container.addRules.bind(container);
  di.config = container.config.bind(container);
  di.wrap = container.wrap.bind(container);
  di.makeRegisterFactory = container.makeRegisterFactory.bind(container);
  di.directoryLoader = container.directoryLoader.bind(container);
  return di;
}

var Sync =
/*#__PURE__*/
function () {
  function Sync(instance) {
    classCallCheck(this, Sync);

    this.instance = instance;
  }

  createClass(Sync, [{
    key: "getInstance",
    value: function getInstance() {
      return this.instance;
    }
  }]);

  return Sync;
}();

var nativePromise$1 = Promise;
function structuredHasPromise(structure, mixed) {
  var PromiseInterface = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : nativePromise$1;

  if (mixed instanceof PromiseInterface) {
    return true;
  }

  if (_typeof_1(structure) === 'object' && structure !== null && !(structure instanceof Var)) {
    return Object.keys(structure).some(function (key) {
      return structuredHasPromise(structure[key], mixed[key], PromiseInterface);
    });
  }
}

var nativePromise$2 = Promise;

function structuredPromiseAllRecursive(structure, value) {
  var PromiseInterface = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : nativePromise$2;
  var PromiseFactory = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : nativePromise$2;

  if (value instanceof PromiseInterface) {
    return value;
  }

  if (!(_typeof_1(structure) === 'object' && structure !== null && !(structure instanceof Var))) {
    return PromiseFactory.resolve(value);
  }

  if (Array.isArray(value)) {
    return PromiseFactory.all(value.map(function (val, key) {
      return structuredPromiseAllRecursive(structure[key], val, PromiseInterface, PromiseFactory);
    }));
  }

  if (_typeof_1(value) === 'object' && value !== null) {
    return resolveObject(structure, value, PromiseInterface, PromiseFactory);
  }

  return PromiseFactory.resolve(value);
}

function resolveObject(structure, object, PromiseInterface, PromiseFactory) {
  var promises = Object.keys(object).map(function (key) {
    return structuredPromiseAllRecursive(structure[key], object[key], PromiseInterface, PromiseFactory).then(function (value) {
      return {
        key: key,
        value: value
      };
    });
  });
  return PromiseFactory.all(promises).then(function (results) {
    return results.reduce(function (obj, pair) {
      obj[pair.key] = pair.value;
      return obj;
    }, {});
  });
}

function structuredResolveParamsInterface(structure, value) {
  if (value instanceof Sync) {
    return value.getInstance();
  }

  if (!(_typeof_1(structure) === 'object' && structure !== null && !(structure instanceof Var))) {
    return value;
  }

  if (Array.isArray(value)) {
    return value.map(function (val, key) {
      return structuredResolveParamsInterface(structure[key], val);
    });
  }

  if (_typeof_1(value) === 'object' && value !== null) {
    var o = {};
    Object.keys(value).map(function (key) {
      o[key] = structuredResolveParamsInterface(structure[key], value[key]);
    });
    return o;
  }

  return value;
}

function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

var isNativeFunction = _isNativeFunction;

var wrapNativeSuper = createCommonjsModule(function (module) {
function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;

  module.exports = _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !isNativeFunction(Class)) return Class;

    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }

    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);

      _cache.set(Class, Wrapper);
    }

    function Wrapper() {
      return construct(Class, arguments, getPrototypeOf(this).constructor);
    }

    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return setPrototypeOf(Wrapper, Class);
  };

  return _wrapNativeSuper(Class);
}

module.exports = _wrapNativeSuper;
});

var interfaceTypeError =
/*#__PURE__*/
function (_TypeError) {
  inherits(interfaceTypeError, _TypeError);

  function interfaceTypeError() {
    var _getPrototypeOf2;

    var _this;

    classCallCheck(this, interfaceTypeError);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = possibleConstructorReturn(this, (_getPrototypeOf2 = getPrototypeOf(interfaceTypeError)).call.apply(_getPrototypeOf2, [this].concat(args)));

    defineProperty(assertThisInitialized(_this), "errorName", 'interfaceTypeError');

    return _this;
  }

  return interfaceTypeError;
}(wrapNativeSuper(TypeError));

function structuredInterfacePrototype(structure, value) {
  if (structure instanceof InterfaceClass) {
    var interfaceClass = structure.getInterfaceClass();

    if (!(value instanceof interfaceClass)) {
      throw new interfaceTypeError('Expected instance of class implementing interface "' + JSON.stringify(_typeof_1(interfaceClass) === 'symbol' ? 'symbol' : interfaceClass) + '" but got "' + JSON.stringify(_typeof_1(value) === 'symbol' ? 'symbol' : value) + '"');
    }
  } else if (Array.isArray(structure)) {
    structure.forEach(function (val, key) {
      return structuredInterfacePrototype(structure[key], value[key]);
    });
  } else if (_typeof_1(structure) === 'object' && structure !== null) {
    Object.keys(structure).map(function (key) {
      return structuredInterfacePrototype(structure[key], value[key]);
    });
  }
}

var promiseInterface = (function () {
  var promiseInterfaces = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [Promise];
  var checkThenMethod = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  return (
    /*#__PURE__*/
    function () {
      function PromiseInterface() {
        classCallCheck(this, PromiseInterface);
      }

      createClass(PromiseInterface, null, [{
        key: Symbol.hasInstance,
        value: function value(instance) {
          if (promiseInterfaces.some(function (promiseInterface) {
            return instance instanceof promiseInterface;
          })) {
            return true;
          }

          if (checkThenMethod && _typeof_1(instance) === 'object' && instance !== null && typeof instance.then === 'function') {
            return true;
          }

          return false;
        }
      }]);

      return PromiseInterface;
    }()
  );
});

var regex = /^[a-zA-Z]{1}:[\\/]|[\\\\]/;
function isWin32AbsolutePath (path) {
  return regex.test(path);
}

var LazyRequire =
/*#__PURE__*/
function () {
  function LazyRequire(container, key, path, rulePath) {
    classCallCheck(this, LazyRequire);

    this.container = container;
    this.key = key;
    this.path = path;
    this.rulePath = rulePath;
  }

  createClass(LazyRequire, [{
    key: "require",
    value: function require() {
      var container = this.container,
          key = this.key,
          path = this.path,
          rulePath = this.rulePath;
      var req = container.requireDep(key, path, rulePath);

      if (req) {
        return container.registerRequire(key, req);
      }
    }
  }]);

  return LazyRequire;
}();

var LazyCall =
/*#__PURE__*/
function () {
  function LazyCall(callback) {
    classCallCheck(this, LazyCall);

    this.callback = callback;
  }

  createClass(LazyCall, [{
    key: "run",
    value: function run() {
      return this.callback.apply(this, arguments);
    }
  }]);

  return LazyCall;
}();

var SEP = PATH.sep;
var SEP_BACK = SEP !== '/';
var interfacePrototypeDefault;
var configMethods = new Map([['rulesDefault', 'setRulesDefault'], ['autoloadFailOnMissingFile', 'setAutoloadFailOnMissingFile'], ['autoloadExtensions', 'setAutoloadExtensions'], ['autoloadPathResolver', 'setAutoloadPathResolver'], ['defaultVar', 'setDefaultVar'], ['defaultRuleVar', 'setDefaultRuleVar'], ['defaultDecoratorVar', 'setDefaultDecoratorVar'], ['defaultArgsVar', 'setDefaultArgsVar'], ['defaultFactory', 'setDefaultFactory'], ['defaultFunctionWrapper', 'setDefaultFunctionWrapper'], ['globalKey', 'setGlobalKey'], ['interfacePrototype', 'setInterfacePrototype'], ['interfaceTypeCheck', 'setInterfaceTypeCheck'], ['ruleCache', 'setRuleCache'], // order matters (sometimes a little performance gain) for theses methods
['promiseFactory', 'setPromiseFactory'], ['promiseInterfaces', 'setPromiseInterfaces'], // order matters for theses methods
['lazyRequire', 'setLazyRequire'], ['dependencies', 'setDependencies'], ['rules', 'addRules'], ['polyfillRequireContext', 'setPolyfillRequireContext']]);
var allowedDefaultVars = ['interface', 'value'];

var Container =
/*#__PURE__*/
function () {
  createClass(Container, null, [{
    key: "setInterfacePrototypeDefault",
    value: function setInterfacePrototypeDefault(interfacePrototype) {
      interfacePrototypeDefault = interfacePrototype;
    }
  }, {
    key: "getInterfacePrototypeDefault",
    value: function getInterfacePrototypeDefault(interfacePrototype) {
      return interfacePrototypeDefault;
    }
  }]);

  function Container() {
    var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, Container);

    defineProperty(this, "requiresLoaded", {});

    this.symClassName = Symbol('className');
    this.symInterfaces = Symbol('types');
    this.providerRegistry = {};
    this.instanceRegistry = {};
    this.requires = {};
    this.dependencies = {};
    this.directoryLoaders = {};
    this.rules = {};
    this.rulesCache = {};
    this.rulesDefault = {
      inheritInstanceOf: true,
      inheritPrototype: false,
      inheritMixins: [],
      shared: false,
      instanceOf: false,
      classDef: false,
      params: false,
      calls: [],
      lazyCalls: [],
      substitutions: [],
      sharedInTree: [],
      singleton: false,
      asyncResolve: false,
      asyncCallsSerie: false,
      asyncCallsParamsSerie: false,
      decorator: false,
      autoload: undefined,
      path: undefined
    };
    this.config(config, true);
  }

  createClass(Container, [{
    key: "config",
    value: function config(key, value) {
      var _this = this;

      if (_typeof_1(key) === 'object') {
        var config = key;
        var init = value;
        configMethods.forEach(function (method, key) {
          if (init || config.hasOwnProperty(key)) {
            _this[method](config[key]);
          }
        });
        return;
      }

      var method = configMethods.get(key);
      this[method](value);
    }
  }, {
    key: "setRuleCache",
    value: function setRuleCache() {
      var ruleCache = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      this.ruleCache = ruleCache;
    }
  }, {
    key: "setDefaultFactory",
    value: function setDefaultFactory() {
      var defaultFactory = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ValueFactory;
      this.DefaultFactory = defaultFactory;
    }
  }, {
    key: "setDefaultFunctionWrapper",
    value: function setDefaultFunctionWrapper() {
      var defaultFunctionWrapper = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ClassFactory;
      this.DefaultFunctionWrapper = defaultFunctionWrapper;
    }
  }, {
    key: "setInterfaceTypeCheck",
    value: function setInterfaceTypeCheck() {
      var interfaceTypeCheck = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      this.interfaceTypeCheck = interfaceTypeCheck;
    }
  }, {
    key: "setInterfacePrototype",
    value: function setInterfacePrototype(interfacePrototype) {
      this.interfacePrototype = interfacePrototype || interfacePrototypeDefault;
    }
  }, {
    key: "setAutoloadFailOnMissingFile",
    value: function setAutoloadFailOnMissingFile() {
      var autoloadFailOnMissingFile = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'path';
      this.autoloadFailOnMissingFile = autoloadFailOnMissingFile;
    }
  }, {
    key: "setDependencies",
    value: function setDependencies(dependencies) {
      if (dependencies === undefined) {
        return;
      }

      Object.assign(this.dependencies, dependencies);
      this.loadPaths(this.dependencies);
      this.registerDirectories(this.dependencies);

      if (!this.lazyRequire) {
        this.registerRequireMap(this.requires);
      }
    }
  }, {
    key: "setPromiseFactory",
    value: function setPromiseFactory() {
      var promiseFactory = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Promise;
      this.PromiseFactory = promiseFactory;
    }
  }, {
    key: "setPromiseInterfaces",
    value: function setPromiseInterfaces() {
      var promiseInterfaces = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [Promise];

      if (!promiseInterfaces.includes(this.PromiseFactory)) {
        promiseInterfaces.unshift(this.PromiseFactory);
      }

      this.PromiseInterface = promiseInterface(promiseInterfaces);
    }
  }, {
    key: "setPolyfillRequireContext",
    value: function setPolyfillRequireContext() {
    }
  }, {
    key: "setLazyRequire",
    value: function setLazyRequire() {
    }
  }, {
    key: "setRulesDefault",
    value: function setRulesDefault() {
      var rulesDefault = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      Object.assign(this.rulesDefault, rulesDefault);
    }
  }, {
    key: "setAutoloadExtensions",
    value: function setAutoloadExtensions() {
      var autoloadExtensions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ['js'];
      this.autoloadExtensions = autoloadExtensions;

      if (Array.isArray(this.autoloadExtensions)) {
        this.loadExtensionRegex = new RegExp('.(' + this.autoloadExtensions.join('|') + ')$');
      } else {
        this.loadExtensionRegex = this.autoloadExtensions;
      }
    }
  }, {
    key: "setAutoloadPathResolver",
    value: function setAutoloadPathResolver() {
      var autoloadPathResolver = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function (path) {
        return path;
      };

      if (_typeof_1(autoloadPathResolver) === 'object') {
        var aliasMap = autoloadPathResolver;

        autoloadPathResolver = function autoloadPathResolver(path) {
          Object.keys(aliasMap).forEach(function (alias) {
            var realPath = PATH.normalize(aliasMap[alias]);

            if (path === alias) {
              path = realPath;
            } else {
              var dir = path.substr(0, alias.length + 1);

              if (dir === alias + '/' || SEP_BACK && dir === alias + SEP) {
                path = PATH.join(realPath, path.substr(alias.length));
              }
            }
          });
          return path;
        };
      }

      this.autoloadPathResolver = autoloadPathResolver;
    }
  }, {
    key: "setGlobalKey",
    value: function setGlobalKey() {
      var globalKey = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (!globalKey) {
        return;
      }

      if (globalKey === true) {
        globalKey = 'di';
      }

      global[globalKey] = makeContainerApi(this);
    }
  }, {
    key: "loadPaths",
    value: function loadPaths(dirs) {
      var _this2 = this;

      Object.keys(dirs).forEach(function (dirKey) {
        var context = dirs[dirKey];

        if (context instanceof Dependency) {
          var dep = context.getDependency();

          _this2.setRequire(dirKey, dep);

          _this2.registerRequire(dirKey, dep);

          return;
        }

        context.keys().sort(function (a, b) {
          if (a.substr(a.lastIndexOf('/')) === 'index') {
            return true;
          }

          if (b.substr(b.lastIndexOf('/')) === 'index') {
            return false;
          }

          return a > b;
        }).forEach(function (filename) {
          var key = filename.replace(/\\/g, '/');

          if (key.substr(0, 2) === './') {
            key = key.substr(2);
          }

          key = dirKey + '/' + key.substr(0, key.lastIndexOf('.') || key.length);
          var pathFragments = key.split('/');
          var lastPathFragment = pathFragments.pop();
          var isDirIndex = lastPathFragment === 'index' || lastPathFragment === pathFragments.pop();
          var keyParent = isDirIndex ? key.substr(0, key.lastIndexOf('/')) : undefined;
          var ctxFilename;

          if (_this2.lazyRequire) {
            ctxFilename = new LazyCall(function () {
              var required = context(filename);

              _this2.registerRequire(key, required);

              isDirIndex && _this2.registerRequire(keyParent, required);
              return required;
            });

            _this2.setRequire(key, ctxFilename);

            isDirIndex && _this2.setRequire(keyParent, ctxFilename);
          } else {
            ctxFilename = context(filename);

            _this2.setRequire(key, ctxFilename);

            isDirIndex && _this2.setRequire(keyParent, ctxFilename);

            _this2.registerRequire(key, ctxFilename);

            isDirIndex && _this2.registerRequire(keyParent, ctxFilename);
          }
        });
      });
    }
  }, {
    key: "registerDirectories",
    value: function registerDirectories(dependencies) {
      var _this3 = this;

      var directoryLoaders = this.directoryLoaders;
      Object.keys(dependencies).forEach(function (dirKey) {
        var context = dependencies[dirKey];

        if (context instanceof Dependency) {
          return;
        }

        directoryLoaders[dirKey] = function (options) {
          var diParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
          var _options$params = options.params,
              params = _options$params === void 0 ? [] : _options$params,
              _options$sharedAsync = options.sharedAsync,
              sharedAsync = _options$sharedAsync === void 0 ? undefined : _options$sharedAsync,
              _options$curry = options.curry,
              curry = _options$curry === void 0 ? false : _options$curry,
              _options$ignore = options.ignore,
              ignore = _options$ignore === void 0 ? [] : _options$ignore,
              _options$getter = options.getter,
              getter = _options$getter === void 0 ? function (key, params) {
            if (ignore.includes(key)) {
              return function () {};
            }

            return function () {
              return _this3.get(dirKey + '/' + key, params);
            };
          } : _options$getter;
          var deps = [].concat(toConsumableArray(params), toConsumableArray(diParams));

          var makeGetterMap = function makeGetterMap() {
            var makeGetter;

            if (curry) {
              makeGetter = function makeGetter(name) {
                return function () {
                  for (var _len = arguments.length, merge = new Array(_len), _key = 0; _key < _len; _key++) {
                    merge[_key] = arguments[_key];
                  }

                  merge.forEach(function (mergeParam, i) {
                    if (_typeof_1(mergeParam) === 'object' && mergeParam !== null) {
                      if (deps[i] === undefined) {
                        deps[i] = {};
                      }

                      Object.keys(mergeParam).forEach(function (key) {
                        deps[i][key] = _this3.value(mergeParam[key]);
                      });
                    }
                  });
                  return getter(name, deps);
                };
              };
            } else {
              makeGetter = function makeGetter(name) {
                return getter(name, deps);
              };
            }

            var getterMap = {};
            context.keys().sort(function (a, b) {
              if (a.substr(a.lastIndexOf('/')) === 'index') {
                return true;
              }

              if (b.substr(b.lastIndexOf('/')) === 'index') {
                return false;
              }

              return a > b;
            }).forEach(function (filename) {
              var key = filename.replace(/\\/g, '/');

              if (key.substr(0, 2) === './') {
                key = key.substr(2);
              } // key = dirKey + '/' + key.substr(0, key.lastIndexOf('.') || key.length)


              key = key.substr(0, key.lastIndexOf('.') || key.length);
              getterMap[key] = makeGetter(key);
              var pathFragments = key.split('/');
              var lastPathFragment = pathFragments.pop();

              if (lastPathFragment === 'index' || lastPathFragment === pathFragments.pop()) {
                var key2 = key.substr(0, key.lastIndexOf('/'));
                getterMap[key2] = makeGetter(key2);
              }
            });
            return getterMap;
          };

          if (sharedAsync) {
            var depPromises = [];
            sharedAsync.forEach(function (asyncDeps, i) {
              Object.keys(asyncDeps).forEach(function (k) {
                depPromises.push(Promise.resolve(_this3.get(asyncDeps[k])).then(function (resolved) {
                  if (!deps[i]) {
                    deps[i] = {};
                  }

                  deps[i][k] = _this3.value(resolved);
                }));
              });
            });
            return Promise.all(depPromises).then(function () {
              return makeGetterMap();
            });
          } else {
            return makeGetterMap();
          }
        };
      });
    }
  }, {
    key: "addRules",
    value: function addRules() {
      var _this4 = this;

      var rules = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (typeof rules === 'function') {
        rules = rules(this);
      }

      Reflect.ownKeys(rules).forEach(function (interfaceName) {
        return _this4.addRule(interfaceName, rules[interfaceName], false);
      });
      this.rulesDetectLazyLoad();
    }
  }, {
    key: "addRule",
    value: function addRule(interfaceName, rule) {
      var detectLazyLoad = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      if (typeof rule === 'function') {
        rule = rule(this);
      }

      if (this.rules[interfaceName] === undefined) {
        this.rules[interfaceName] = {};
      }

      this.rules[interfaceName] = this.mergeRule(this.rules[interfaceName], rule);
      this.processRule(interfaceName);
      rule = this.rules[interfaceName];
      var _rule = rule,
          classDef = _rule.classDef;

      if (classDef) {
        if (classDef instanceof ClassDef) {
          classDef = classDef.getClassDef();
        }

        this.registerRequire(interfaceName, classDef);
      }

      if (detectLazyLoad) {
        this.rulesDetectLazyLoad();
      }
    }
  }, {
    key: "setDefaultVar",
    value: function setDefaultVar(value) {
      this._setDefaultVar(value, 'defaultVar');
    }
  }, {
    key: "setDefaultRuleVar",
    value: function setDefaultRuleVar(value) {
      this._setDefaultVar(value, 'defaultRuleVar');
    }
  }, {
    key: "setDefaultDecoratorVar",
    value: function setDefaultDecoratorVar(value) {
      this._setDefaultVar(value, 'defaultDecoratorVar');
    }
  }, {
    key: "setDefaultArgsVar",
    value: function setDefaultArgsVar(value) {
      this._setDefaultVar(value, 'defaultArgsVar');
    }
  }, {
    key: "_setDefaultVar",
    value: function _setDefaultVar(value, property) {
      if (value === undefined) {
        value = this.defaultVar || 'interface';
      }

      if (!allowedDefaultVars.includes(value)) {
        throw new Error('invalid type "' + value + '" specified for ' + property + ', possibles values: ' + allowedDefaultVars.join(' | '));
      }

      this[property] = value;
    }
  }, {
    key: "rulesDetectLazyLoad",
    value: function rulesDetectLazyLoad() {
      var _this5 = this;

      Object.keys(this.rules).forEach(function (key) {
        _this5.ruleLazyLoad(key);
      });
    }
  }, {
    key: "ruleLazyLoad",
    value: function ruleLazyLoad(key) {
      var _this6 = this;
      var calls = [];
      var lazyCalls = [];
      var rule = this.rules[key];

      if (!rule.calls) {
        return;
      }

      rule.calls.forEach(function (callVal) {
        if (typeof callVal === 'function') {
          callVal = [callVal];
        }

        var _callVal = callVal,
            _callVal2 = slicedToArray(_callVal, 2),
            _callVal2$ = _callVal2[1],
            params = _callVal2$ === void 0 ? [] : _callVal2$;

        if (_this6.ruleCheckCyclicLoad(params, [key])) {
          lazyCalls.push(callVal);
        } else {
          calls.push(callVal);
        }
      });
      rule.calls = calls;
      rule.lazyCalls = (rule.lazyCalls || []).concat(lazyCalls);
    }
  }, {
    key: "ruleCheckCyclicLoad",
    value: function ruleCheckCyclicLoad(params) {
      var _this7 = this;

      var stack = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      return Object.keys(params).some(function (k) {
        var param = params[k];

        var v = _this7.wrapVarType(param, _this7.defaultRuleVar);

        if (v instanceof Interface) {
          var interfaceName = v.getName();

          if (!_this7.resolveInstanceOf(interfaceName, [], false)) {
            // not found, unable to check now
            return false;
          }

          var paramRule = _this7.buildRule(interfaceName);

          if (stack.includes(interfaceName)) {
            return true;
          }

          stack.push(interfaceName);
          var cyclic;

          if (paramRule.params) {
            cyclic = _this7.ruleCheckCyclicLoad(paramRule.params, stack);
          }

          if (!cyclic) {
            cyclic = paramRule.calls.some(function (callV) {
              var _callV = slicedToArray(callV, 2),
                  _callV$ = _callV[1],
                  params = _callV$ === void 0 ? [] : _callV$;

              return _this7.ruleCheckCyclicLoad(params, stack);
            });
          }

          return cyclic;
        }

        if (_typeof_1(v) === 'object' && v !== null && !(v instanceof Var)) {
          return _this7.ruleCheckCyclicLoad(v, stack);
        }
      });
    }
  }, {
    key: "processRule",
    value: function processRule(key) {
      var _this8 = this;

      var stack = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

      if (this.rules[key] === undefined) {
        this.rules[key] = {};
      }

      var rule = this.mergeRule(this.mergeRule({}, this.rulesDefault), this.rules[key]);

      if (rule.instanceOf) {
        if (stack.includes(key)) {
          throw new Error('Cyclic interface definition error in ' + JSON.stringify(stack.concat(key), null, 2));
        }

        stack.push(key);
        this.processRule(rule.instanceOf, stack);
      }

      if (rule.directory) {
        var _rule$directory = rule.directory,
            path = _rule$directory.path,
            options = objectWithoutProperties(_rule$directory, ["path"]);

        this.rules[key].classDef = this.directoryLoader(path, options);
      }

      if (rule.singleton) {
        this.rules[key].classDef = function () {
          return rule.singleton;
        };
      }

      if (typeof rule.classDef === 'string') {
        var classDefName = rule.classDef;

        this.rules[key].classDef = function () {
          var ClassDefinition = _this8.get(classDefName);

          for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
          }

          return construct(ClassDefinition, args);
        };
      }

      if (rule.autoload && !rule.classDef || rule.path) {
        var _path = rule.path;

        if (!_path) {
          if (rule.instanceOf) {
            if (this.rules[rule.instanceOf]) {
              return;
            }

            _path = rule.instanceOf;
          } else if (this.validateAutoloadFileName(key)) {
            _path = key;
          } else {
            return;
          }
        }

        if (this.lazyRequire) {
          this.rules[key].classDef = new LazyRequire(this, key, _path, rule.path);
        } else {
          var req = this.requireDep(key, _path, rule.path);

          if (req) {
            this.registerRequire(key, req);
          }
        }
      }
    }
  }, {
    key: "validateAutoloadFileName",
    value: function validateAutoloadFileName(name) {
      if (typeof name === 'string' && name.substr(0, 1) === '#') {
        return false;
      }

      return true;
    }
  }, {
    key: "requireDep",
    value: function requireDep(key, requirePath, rulePath) {
      var _this9 = this;

      var cached = this.getRequire(key);

      if (cached) {
        return cached;
      }

      requirePath = this.autoloadPathResolver(requirePath);
      if (_typeof_1(requirePath) === 'symbol') return;
      var required;
      var found = this.autoloadExtensions.concat('').some(function (ext) {
        var prefix = '';
        var pathFragments = requirePath.split(':');

        if (isWin32AbsolutePath(requirePath)) {
          prefix = pathFragments.shift() + ':';
        }

        var path = prefix + pathFragments.shift();

        if (ext) {
          path += '.' + ext;
        }

        if (_this9.depExists(path)) {
          required = _this9.depRequire(path);

          if (pathFragments.length) {
            pathFragments.forEach(function (subKey) {
              if (typeof required !== 'undefined' && required !== null) {
                required = required[subKey];
              }
            });
          }

          _this9.setRequire(key, required);

          return true;
        }
      });

      if (!found && (this.autoloadFailOnMissingFile === 'path' && rulePath || this.autoloadFailOnMissingFile === true)) {
        throw new Error('Missing expected dependency injection file "' + requirePath + '" for rule key "' + key + '"');
      }

      return required;
    }
  }, {
    key: "setRequire",
    value: function setRequire(key, required) {
      var _this10 = this;

      key = PATH.normalize(key);
      Object.defineProperty(this.requires, key, {
        get: function get() {
          if (!(key in _this10.requiresLoaded)) {
            _this10.requiresLoaded[key] = required instanceof LazyCall ? required.run() : required;
          }

          return _this10.requiresLoaded[key];
        },
        enumerable: true,
        configurable: true
      });
    }
  }, {
    key: "getRequire",
    value: function getRequire(key) {
      if (typeof key === 'string') {
        key = PATH.normalize(key);
      }

      return this.requires[key];
    }
  }, {
    key: "registerRequireMap",
    value: function registerRequireMap(requires) {
      var _this11 = this;

      Object.keys(requires).forEach(function (name) {
        _this11.registerRequire(name, requires[name]);
      });
    }
  }, {
    key: "registerRequire",
    value: function registerRequire(name, _r) {
      if (typeof name === 'string') {
        name = name.replace(/\\/g, '/');
      }

      if (_typeof_1(_r) === 'object' && typeof _r.default === 'function') {
        _r = _r.default;
      }

      if (typeof _r !== 'function') {
        return;
      }

      var rule = this.getRuleBase(name);

      if (rule.decorator && _r[this.symClassName]) {
        _r =
        /*#__PURE__*/
        function (_r2) {
          inherits(r, _r2);

          function r() {
            classCallCheck(this, r);

            return possibleConstructorReturn(this, getPrototypeOf(r).apply(this, arguments));
          }

          return r;
        }(_r);
      }

      if (rule.decorator) {
        this.decorator(name)(_r);
      } else {
        this.registerClass(name, _r);
      }

      return _r;
    }
  }, {
    key: "wrap",
    value: function wrap() {
      var _this12 = this;

      var types = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      var _wrap = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      return function (target, method) {
        target[method] = _this12.decoratorMethod(target, method, types, _wrap);
        return target;
      };
    }
  }, {
    key: "decorator",
    value: function decorator() {
      var _this13 = this;

      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      return function (target, method) {
        if (method === undefined) {
          var className = args[0],
              _args$ = args[1],
              types = _args$ === void 0 ? [] : _args$;

          _this13.decoratorClass(target, className, types);
        } else {
          var _args$2 = args[0],
              _types = _args$2 === void 0 ? [] : _args$2,
              _args$3 = args[1],
              wrap = _args$3 === void 0 ? false : _args$3;

          target[method] = _this13.decoratorMethod(target, method, _types, wrap);
        }

        return target;
      };
    }
  }, {
    key: "decoratorClass",
    value: function decoratorClass(target, className, types) {
      var _this14 = this;

      this.defineSym(target, this.symClassName, className);
      this.registerClass(className, target);

      if (typeof types === 'function') {
        types = types();
      }

      types = types.map(function (type) {
        return _this14.wrapVarType(type, _this14.defaultDecoratorVar);
      });

      if (target[this.symInterfaces]) {
        types = types.concat(target[this.symInterfaces]);
      }

      this.defineSym(target, this.symInterfaces, types);
      return target;
    }
  }, {
    key: "decoratorMethod",
    value: function decoratorMethod(target, method, types, wrap, interfaceName) {
      var _this15 = this;

      if (typeof types === 'function') {
        types = types();
      }

      types = types.map(function (type) {
        return _this15.wrapVarType(type, _this15.defaultDecoratorVar);
      });
      var fn = target[method];

      if (wrap) {
        var self = this;
        return function () {
          var rule = self.getRuleBase(interfaceName || target[self.symClassName]);
          var params = types.map(function (param) {
            return self.getParam(param, rule, {}, self.defaultRuleVar);
          });
          var resolvedParams = structuredResolveParamsInterface(types, params);
          return Reflect.apply(fn, this, resolvedParams);
        };
      } else {
        if (fn[this.symInterfaces]) {
          types = types.concat(fn[this.symInterfaces]);
        }

        this.defineSym(fn, this.symInterfaces, types);
        return fn;
      }
    }
  }, {
    key: "exists",
    value: function exists(name) {
      return Boolean(this.rules[name]) || name in this.requires;
    }
  }, {
    key: "get",
    value: function get(interfaceDef, args) {
      var sharedInstances = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var stack = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];
      return this.provider(interfaceDef)(args, sharedInstances, stack);
    }
  }, {
    key: "provider",
    value: function provider(interfaceName) {
      if (typeof interfaceName === 'function' && this.isInterfacePrototype(interfaceName)) {
        interfaceName = interfaceName.toString();
      }

      if (typeof interfaceName === 'function') {
        interfaceName = interfaceName[this.symClassName];

        if (!interfaceName) {
          throw new Error('Unregistred class ' + interfaceName.constructor.name);
        }
      }

      if (interfaceName instanceof Interface) {
        interfaceName = interfaceName.getName();
      }

      if (!this.providerRegistry[interfaceName]) {
        this.providerRegistry[interfaceName] = this.makeProvider(interfaceName);
      }

      return this.providerRegistry[interfaceName];
    }
  }, {
    key: "makeProvider",
    value: function makeProvider(interfaceName) {
      var _this16 = this;

      var rule = this.getRule(interfaceName);
      var ClassDef = rule.resolvedInstanceOf;
      return function (args, sharedInstances, stack) {
        // check for shared after params load
        if (_this16.instanceRegistry[interfaceName]) {
          return _this16.instanceRegistry[interfaceName];
        }

        sharedInstances = Object.assign({}, sharedInstances);
        rule.sharedInTree.forEach(function (shareInterface) {
          if (!sharedInstances[shareInterface]) {
            sharedInstances[shareInterface] = new SharedInstance(shareInterface, _this16);
          }
        });
        var params;
        var defaultVar;

        if (args) {
          params = args;
          defaultVar = _this16.defaultArgsVar;
        } else {
          params = rule.params || ClassDef[_this16.symInterfaces] || [];
          defaultVar = _this16.defaultRuleVar;
        }

        var resolvedParams = params.map(function (interfaceDef, index) {
          return _this16.getParam(interfaceDef, rule, sharedInstances, defaultVar, index, stack);
        }); // recheck for shared after params load

        if (_this16.instanceRegistry[interfaceName]) {
          return _this16.instanceRegistry[interfaceName];
        }

        var makeInstance = function makeInstance(resolvedParams) {
          resolvedParams = structuredResolveParamsInterface(params, resolvedParams);

          if (ClassDef instanceof LazyRequire) {
            ClassDef = ClassDef.require();
          }

          if (_this16.interfaceTypeCheck) {
            structuredInterfacePrototype(rule.params || ClassDef[_this16.symInterfaces] || [], resolvedParams);
          }

          var instance = construct(ClassDef, toConsumableArray(resolvedParams));

          var finalizeInstanceCreation = function finalizeInstanceCreation() {
            if (rule.shared) {
              _this16.registerInstance(interfaceName, instance);
            }

            var callsReturn = _this16.runCalls(rule.lazyCalls, instance, rule, sharedInstances);

            if (callsReturn instanceof _this16.PromiseInterface) {
              return callsReturn.then(function () {
                return instance;
              });
            }

            return instance;
          };

          var callsReturn = _this16.runCalls(rule.calls, instance, rule, sharedInstances);

          if (callsReturn instanceof _this16.PromiseInterface) {
            return callsReturn.then(function () {
              return finalizeInstanceCreation();
            });
          }

          return finalizeInstanceCreation();
        };

        if (structuredHasPromise(params, resolvedParams, _this16.PromiseInterface)) {
          return structuredPromiseAllRecursive(params, resolvedParams, _this16.PromiseInterface, _this16.PromiseFactory).then(function (resolvedParams) {
            return makeInstance(resolvedParams);
          });
        }

        return makeInstance(resolvedParams);
      };
    }
  }, {
    key: "getSubstitutionParam",
    value: function getSubstitutionParam(interfaceDef, rule, index) {
      var substitutions = this.wrapVarType(rule.substitutions, this.defaultRuleVar);

      if (typeof index !== 'undefined' && substitutions[index]) {
        interfaceDef = substitutions[index];
        interfaceDef = this.wrapVarType(interfaceDef, this.defaultRuleVar, true);
      }

      if (interfaceDef instanceof Interface) {
        var interfaceName = interfaceDef.getName();

        if (substitutions[interfaceName]) {
          interfaceDef = substitutions[interfaceName];
          interfaceDef = this.wrapVarType(interfaceDef, this.defaultRuleVar, true);
        }
      }

      return interfaceDef;
    }
  }, {
    key: "getParam",
    value: function getParam(interfaceDef, rule) {
      var _this17 = this;

      var sharedInstances = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var defaultVar = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 'interface';
      var index = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : undefined;
      var stack = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : [];
      interfaceDef = this.wrapVarType(interfaceDef, defaultVar);
      interfaceDef = this.getSubstitutionParam(interfaceDef, rule, index);

      if (interfaceDef instanceof Factory) {
        return interfaceDef.callback(sharedInstances);
      }

      if (interfaceDef instanceof Value) {
        return interfaceDef.getValue();
      }

      if (interfaceDef instanceof Require) {
        return interfaceDef.require();
      }

      if (interfaceDef instanceof Interface) {
        var interfaceName = interfaceDef.getName();
        stack = stack.slice(0);

        if (stack.includes(interfaceName)) {
          throw new Error('Cyclic dependency error in ' + JSON.stringify(stack.concat(interfaceName), null, 2));
        }

        stack.push(interfaceName);
        var instance;

        if (sharedInstances[interfaceName]) {
          instance = sharedInstances[interfaceName].get(sharedInstances, stack);
        } else {
          instance = this.get(interfaceName, undefined, sharedInstances, stack);
        }

        var instanceRule = this.getRule(interfaceName); // if(!instanceRule.asyncResolve && instance instanceof this.PromiseInterface){

        if (!instanceRule.asyncResolve) {
          return new Sync(instance);
        }

        return instance;
      }

      if (_typeof_1(interfaceDef) === 'object' && !(interfaceDef instanceof Var)) {
        if (Array.isArray(interfaceDef)) {
          return interfaceDef.map(function (interfaceDefVal) {
            return _this17.getParam(interfaceDefVal, rule, sharedInstances, defaultVar, undefined, stack);
          });
        } else {
          var o = {};
          Object.keys(interfaceDef).forEach(function (k) {
            o[k] = _this17.getParam(interfaceDef[k], rule, sharedInstances, defaultVar, undefined, stack);
          });
          return o;
        }
      }

      return interfaceDef;
    }
  }, {
    key: "wrapVarType",
    value: function wrapVarType(type, defaultVar, resolveFunction) {
      var _this18 = this;

      if (resolveFunction && typeof type === 'function') {
        type = type();
      }

      if (type instanceof Var) {
        return type;
      }

      if (this.isInterfacePrototype(type)) {
        return this.interfaceClass(type.toString(), type);
      }

      switch (defaultVar) {
        case 'interface':
          if (_typeof_1(type) === 'object' && type !== null) {
            if (Array.isArray(type)) {
              return type.map(function (v) {
                return _typeof_1(v) === 'object' && v !== null && !(v instanceof Var) ? _this18.wrapVarType(v, defaultVar) : v;
              });
            } else {
              var o = {};
              Object.keys(type).forEach(function (key) {
                var v = type[key];
                o[key] = _typeof_1(v) === 'object' && v !== null && !(v instanceof Var) ? _this18.wrapVarType(v, defaultVar) : v;
              });
              return o;
            }
          }

          if (typeof type === 'function') {
            return new this.DefaultFunctionWrapper(type);
          }

          return this.interface(type);

        case 'value':
          return this.value(type);
      }

      return type;
    }
  }, {
    key: "isInterfacePrototype",
    value: function isInterfacePrototype(type) {
      return this.interfacePrototype !== undefined && type.prototype instanceof this.interfacePrototype;
    }
  }, {
    key: "registerInstance",
    value: function registerInstance(name, instance) {
      this.instanceRegistry[name] = instance;
    }
  }, {
    key: "getRuleBase",
    value: function getRuleBase(interfaceName) {
      var ruleBase = this.mergeRule({}, this.rulesDefault);
      ruleBase.interfaceName = interfaceName; // for info

      if (interfaceName) {
        this.mergeRule(ruleBase, this.rules[interfaceName] || {});
      }

      return ruleBase;
    }
  }, {
    key: "getRule",
    value: function getRule(interfaceName) {
      if (this.ruleCache && this.rulesCache[interfaceName]) {
        return this.rulesCache[interfaceName];
      }

      var rule = this.buildRule(interfaceName);

      if (this.ruleCache) {
        this.rulesCache[interfaceName] = rule;
      }

      return rule;
    }
  }, {
    key: "buildRule",
    value: function buildRule(interfaceName) {
      var _this19 = this;

      var rule = this.mergeRule({}, this.rulesDefault);
      rule.interfaceName = interfaceName; // for info

      if (!interfaceName) {
        return rule;
      }

      var ruleBase = this.getRuleBase(interfaceName);
      var stack = [];
      var resolvedInstanceOf = this.resolveInstanceOf(interfaceName, stack);
      var fullStack;

      if (ruleBase.inheritInstanceOf) {
        fullStack = new Set(stack.slice(0, -1));
      } else {
        fullStack = new Set(stack.slice(0, 1));
      }

      if (ruleBase.inheritPrototype) {
        stack.reverse().forEach(function (c) {
          if (typeof c === 'function') {
            var parentProto = c;
            var className;

            while (parentProto) {
              className = parentProto[_this19.symClassName];

              if (className) {
                fullStack.add(className);
              }

              parentProto = Reflect.getPrototypeOf(parentProto);
            }
          }
        });
      }

      fullStack = Array.from(fullStack).reverse();
      fullStack.forEach(function (className) {
        var mergeRule = _this19.rules[className];

        if (mergeRule.inheritMixins) {
          _this19.mixinsRule(rule, mergeRule.inheritMixins);
        }

        _this19.mergeRule(rule, mergeRule);
      });
      rule.resolvedInstanceOf = resolvedInstanceOf;
      return rule;
    }
  }, {
    key: "mixinsRule",
    value: function mixinsRule(rule, mixinsGroup) {
      var _this20 = this;

      var mixinsGroups = this.ruleCollectExtendsRecursive(mixinsGroup).reverse();
      mixinsGroups.forEach(function (mixinGroup) {
        return mixinGroup.forEach(function (mixin) {
          var mergeRule = _this20.rules[mixin];

          _this20.mergeRule(rule, mergeRule, false);
        });
      });
    }
  }, {
    key: "ruleCollectExtendsRecursive",
    value: function ruleCollectExtendsRecursive(mixinGroup) {
      var _this21 = this;

      var mixinsGroups = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

      if (!Array.isArray(mixinGroup)) {
        mixinGroup = [mixinGroup];
      }

      mixinsGroups.push(mixinGroup);
      mixinGroup.forEach(function (mixin) {
        var rule = _this21.rules[mixin];

        if (rule && rule.mixins) {
          _this21.ruleCollectExtendsRecursive(rule.mixins, mixinsGroups);
        }
      });
      return mixinsGroups;
    }
  }, {
    key: "registerClass",
    value: function registerClass(name, target) {
      if (!this.rules[name]) {
        this.rules[name] = {};
      }

      this.rules[name].classDef = target;
    }
  }, {
    key: "mergeRule",
    value: function mergeRule(extendRule, rule) {
      var mergeExtend = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var shared = rule.shared,
          inheritInstanceOf = rule.inheritInstanceOf,
          inheritPrototype = rule.inheritPrototype,
          inheritMixins = rule.inheritMixins,
          instanceOf = rule.instanceOf,
          params = rule.params,
          calls = rule.calls,
          lazyCalls = rule.lazyCalls,
          substitutions = rule.substitutions,
          sharedInTree = rule.sharedInTree,
          classDef = rule.classDef,
          singleton = rule.singleton,
          directory = rule.directory,
          asyncResolve = rule.asyncResolve,
          asyncCallsSerie = rule.asyncCallsSerie,
          asyncCallsParamsSerie = rule.asyncCallsParamsSerie,
          decorator = rule.decorator,
          autoload = rule.autoload,
          path = rule.path;

      if (classDef !== undefined) {
        extendRule.classDef = classDef;
      }

      if (directory !== undefined) {
        extendRule.directory = directory;
      }

      if (shared !== undefined) {
        extendRule.shared = shared;
      }

      if (inheritInstanceOf !== undefined) {
        extendRule.inheritInstanceOf = inheritInstanceOf;
      }

      if (inheritPrototype !== undefined) {
        extendRule.inheritPrototype = inheritPrototype;
      }

      if (decorator !== undefined) {
        extendRule.decorator = decorator;
      }

      if (autoload !== undefined) {
        extendRule.autoload = autoload;
      }

      if (path !== undefined) {
        extendRule.path = path;
      }

      if (instanceOf !== undefined) {
        extendRule.instanceOf = instanceOf;
      }

      if (asyncResolve !== undefined) {
        extendRule.asyncResolve = asyncResolve;
      }

      if (asyncCallsSerie !== undefined) {
        extendRule.asyncCallsSerie = asyncCallsSerie;
      }

      if (asyncCallsParamsSerie !== undefined) {
        extendRule.asyncCallsParamsSerie = asyncCallsParamsSerie;
      }

      if (calls !== undefined) {
        extendRule.calls = (extendRule.calls || []).concat(calls);
      }

      if (lazyCalls !== undefined) {
        extendRule.lazyCalls = (extendRule.lazyCalls || []).concat(lazyCalls);
      }

      if (mergeExtend && inheritMixins !== undefined) {
        extendRule.inheritMixins = inheritMixins.slice(0);
      }

      if (params !== undefined) {
        extendRule.params = params;
      }

      if (substitutions !== undefined) {
        if (!extendRule.substitutions) {
          extendRule.substitutions = {};
        }

        Object.assign(extendRule.substitutions, substitutions);
      }

      if (sharedInTree !== undefined) {
        if (!extendRule.sharedInTree) {
          extendRule.sharedInTree = [];
        }

        extendRule.sharedInTree = Array.from(new Set([].concat(toConsumableArray(extendRule.sharedInTree), toConsumableArray(sharedInTree))));
      }

      extendRule.singleton = singleton;
      return extendRule;
    }
  }, {
    key: "mergeRules",
    value: function mergeRules(extendRules, rules) {
      var _this22 = this;

      Object.keys(rules).forEach(function (k) {
        if (!extendRules[k]) {
          extendRules[k] = {};
        }

        extendRules[k] = _this22.mergeRule(extendRules[k], rules[k]);
      });
      return extendRules;
    }
  }, {
    key: "runCalls",
    value: function runCalls(calls, instance, rule, sharedInstances) {
      var _this23 = this;

      var hasAsync;
      var callers = calls.map(function (c) {
        return function () {
          if (typeof c === 'function') {
            c = [c];
          }

          var _c = c,
              _c2 = slicedToArray(_c, 3),
              method = _c2[0],
              params = _c2[1],
              _c2$ = _c2[2],
              asyncResolve = _c2$ === void 0 ? rule.asyncResolve : _c2$;

          if (params === undefined) {
            if (typeof method !== 'function') {
              params = instance[method][_this23.symInterfaces];
            }

            if (params === undefined) {
              params = [];
            }
          }

          var makeCall = function makeCall(resolvedParams) {
            resolvedParams = structuredResolveParamsInterface(params, resolvedParams);
            var callReturn;

            if (typeof method === 'function') {
              callReturn = method.apply(void 0, [instance].concat(toConsumableArray(resolvedParams)));
            } else {
              callReturn = instance[method].apply(instance, toConsumableArray(resolvedParams));
            }

            if (!asyncResolve) {
              callReturn = new Sync(callReturn);
            }

            return callReturn;
          };

          var resolvedParams = params.map(function (param) {
            return _this23.getParam(param, rule, sharedInstances, _this23.defaultRuleVar);
          });

          if (structuredHasPromise(params, resolvedParams, _this23.PromiseInterface)) {
            hasAsync = true;
            return function () {
              return structuredPromiseAllRecursive(params, resolvedParams, _this23.PromiseInterface, _this23.PromiseFactory).then(function (resolvedParams) {
                return makeCall(resolvedParams);
              });
            };
          } else {
            return function () {
              return makeCall(resolvedParams);
            };
          }
        };
      });
      var asyncCallsParamsSerie = rule.asyncCallsParamsSerie;
      var asyncCallsSerie = rule.asyncCallsSerie || asyncCallsParamsSerie;

      var makeCalls = function makeCalls(callers) {
        var callersReturn;

        if (hasAsync) {
          if (asyncCallsSerie) {
            callersReturn = mapSerie(callers, function (caller) {
              return caller();
            }, _this23.PromiseInterface, _this23.PromiseFactory);
          } else {
            callersReturn = _this23.PromiseFactory.all(callers.map(function (caller) {
              return caller();
            }));
          }
        } else {
          callersReturn = callers.map(function (caller) {
            var callerReturn = caller();

            if (callerReturn instanceof _this23.PromiseInterface) {
              hasAsync = true;
            }

            return callerReturn;
          });

          if (hasAsync) {
            callersReturn = _this23.PromiseFactory.all(callersReturn);
          }
        }

        return callersReturn;
      };

      if (asyncCallsParamsSerie) {
        callers = mapSerie(callers, function (caller) {
          caller = caller()();
          return caller;
        }, this.PromiseInterface, this.PromiseFactory);
        return callers.then(function (callers) {
          return makeCalls(callers.map(function (caller) {
            return function () {
              return caller;
            };
          }));
        });
      } else {
        callers = callers.map(function (caller) {
          return caller();
        });
        return makeCalls(callers);
      }
    }
  }, {
    key: "defineSym",
    value: function defineSym(target, symname, value) {
      Reflect.defineProperty(target, symname, {
        value: value,
        enumerable: false,
        configurable: true
      });
    }
  }, {
    key: "resolveInstanceOf",
    value: function resolveInstanceOf(str) {
      var stack = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var required = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      if (typeof str === 'string' || _typeof_1(str) === 'symbol') {
        if (stack.includes(str)) {
          throw new Error('Cyclic interface definition error in ' + JSON.stringify(stack.concat(str), null, 2));
        }

        stack.push(str);

        if (require) {
          this.getRequire(str);
        }

        var rule = this.rules[str];
        var resolved = false;

        if (rule) {
          if (rule.instanceOf) {
            resolved = rule.instanceOf;
          } else if (rule.classDef) {
            resolved = rule.classDef;
          }
        }

        if (!resolved) {
          if (!required) {
            return false;
          }

          throw new Error('Interface definition ' + (_typeof_1(str) === 'symbol' ? 'symbol' : '"' + str + '"') + ' not found, di load stack: ' + JSON.stringify(stack, null, 2));
        }

        return this.resolveInstanceOf(resolved, stack, required);
      }

      stack.push(str);
      return str;
    }
  }, {
    key: "makeRegisterFactory",
    value: function makeRegisterFactory(prefixPath) {
      var dependencies = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var asyncSharedDepsArray = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;
      var curry = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      var ignore = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : ['then'];
      var di = this;
      return function () {
        for (var _len4 = arguments.length, params = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
          params[_key4] = arguments[_key4];
        }

        var deps = [].concat(toConsumableArray(dependencies), params);

        function makeProxy() {
          var make;

          if (curry) {
            make = function make(name) {
              return function () {
                for (var _len5 = arguments.length, merge = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
                  merge[_key5] = arguments[_key5];
                }

                merge.forEach(function (mergeParam, i) {
                  if (_typeof_1(mergeParam) === 'object' && mergeParam !== null) {
                    if (deps[i] === undefined) {
                      deps[i] = {};
                    }

                    Object.keys(mergeParam).forEach(function (key) {
                      deps[i][key] = di.value(mergeParam[key]);
                    });
                  }
                });
                return di.get(prefixPath + name, deps);
              };
            };
          } else {
            make = function make(name) {
              return di.get(prefixPath + name, deps);
            };
          }

          return new Proxy({}, {
            get: function get(o, k) {
              if (ignore.includes(k)) {
                return;
              }

              if (o[k] === undefined) {
                o[k] = make(k);
              }

              return o[k];
            }
          });
        }

        if (asyncSharedDepsArray) {
          var depPromises = [];
          asyncSharedDepsArray.forEach(function (asyncSharedDeps, i) {
            Object.keys(asyncSharedDeps).forEach(function (k) {
              depPromises.push(Promise.resolve(di.get(asyncSharedDeps[k])).then(function (resolved) {
                if (!deps[i]) {
                  deps[i] = {};
                }

                deps[i][k] = di.value(resolved);
              }));
            });
          });
          return Promise.all(depPromises).then(function () {
            return makeProxy();
          });
        } else {
          return makeProxy();
        }
      };
    }
  }, {
    key: "directoryLoader",
    value: function directoryLoader(dir, options) {
      var _this24 = this;

      return function () {
        function getterMapToRegistry(getterMap) {
          var registry = {};
          Object.entries(getterMap).forEach(function (_ref) {
            var _ref2 = slicedToArray(_ref, 2),
                key = _ref2[0],
                getter = _ref2[1];

            Object.defineProperty(registry, key, {
              get: function get() {
                return getter();
              }
            });
          });
          return registry;
        }

        var loader = _this24.directoryLoaders[dir];

        if (!loader) {
          throw new Error('Directory not found "' + dir + '"');
        }

        for (var _len6 = arguments.length, diParams = new Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
          diParams[_key6] = arguments[_key6];
        }

        var getterMap = loader(options, diParams);

        if (getterMap instanceof Promise) {
          return getterMap.then(function (getterMapResolved) {
            return getterMapToRegistry(getterMapResolved);
          });
        } else {
          return getterMapToRegistry(getterMap);
        }
      };
    }
  }, {
    key: "factory",
    value: function factory(callback) {
      return new this.DefaultFactory(callback);
    }
  }, {
    key: "valueFactory",
    value: function valueFactory(callback) {
      return new ValueFactory(callback);
    }
  }, {
    key: "classFactory",
    value: function classFactory(callback) {
      return new ClassFactory(callback);
    }
  }, {
    key: "interface",
    value: function _interface(name) {
      return new Interface(name);
    }
  }, {
    key: "interfaceClass",
    value: function interfaceClass(name, _interfaceClass) {
      return new InterfaceClass(name, _interfaceClass);
    }
  }, {
    key: "value",
    value: function value(_value) {
      return new Value(_value);
    }
  }, {
    key: "require",
    value: function require(dep) {
      return new Require(dep);
    }
  }, {
    key: "dependency",
    value: function dependency(dep) {
      return new Dependency(dep);
    }
  }, {
    key: "classDef",
    value: function classDef(callback) {
      return new ClassDef(callback);
    }
  }]);

  return Container;
}();

var BrowserRequire =
/*#__PURE__*/
function (_Require) {
  inherits(BrowserRequire, _Require);

  function BrowserRequire() {
    classCallCheck(this, BrowserRequire);

    return possibleConstructorReturn(this, getPrototypeOf(BrowserRequire).apply(this, arguments));
  }

  return BrowserRequire;
}(Require);

var InterfaceClass$1 =
/*#__PURE__*/
function () {
  function InterfaceClass(classDef) {
    classCallCheck(this, InterfaceClass);

    this.classDef = classDef;
  }

  createClass(InterfaceClass, [{
    key: "getClass",
    value: function getClass() {
      return this.classDef;
    }
  }]);

  return InterfaceClass;
}();
var InterfacePrototype = function InterfacePrototype() {
  classCallCheck(this, InterfacePrototype);
};
function Interface$1() {
  for (var _len = arguments.length, interfaces = new Array(_len), _key = 0; _key < _len; _key++) {
    interfaces[_key] = arguments[_key];
  }

  var name;

  if (typeof interfaces[0] === 'string' || _typeof_1(interfaces[0]) === 'symbol') {
    name = interfaces.shift();
  } else {
    name = Symbol('Interface');
  }

  return (
    /*#__PURE__*/
    function (_InterfacePrototype) {
      inherits(InterfaceClassIntance, _InterfacePrototype);

      function InterfaceClassIntance() {
        classCallCheck(this, InterfaceClassIntance);

        return possibleConstructorReturn(this, getPrototypeOf(InterfaceClassIntance).apply(this, arguments));
      }

      createClass(InterfaceClassIntance, null, [{
        key: Symbol.hasInstance,
        value: function value(instance) {
          return interfaces.some(function (interfaceDef) {
            if (interfaceDef instanceof InterfaceClass$1) {
              interfaceDef = interfaceDef.getClass();
              return instance instanceof interfaceDef;
            }

            return interfaceDef(instance);
          });
        }
      }, {
        key: "implementClass",
        value: function implementClass() {
          for (var _len2 = arguments.length, classes = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            classes[_key2] = arguments[_key2];
          }

          classes.forEach(function (classDef) {
            return interfaces.push(new InterfaceClass$1(classDef));
          });
        }
      }, {
        key: "getInterfaces",
        value: function getInterfaces() {
          return interfaces;
        }
      }, {
        key: "getName",
        value: function getName() {
          return name;
        }
      }, {
        key: "setName",
        value: function setName(v) {
          name = v;
        }
      }, {
        key: "toString",
        value: function toString() {
          return name;
        }
      }]);

      return InterfaceClassIntance;
    }(InterfacePrototype)
  );
}
function instanceOf() {
  for (var _len3 = arguments.length, interfaceClasses = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
    interfaceClasses[_key3] = arguments[_key3];
  }

  return function (classDef) {
    interfaceClasses.forEach(function (InterfaceClass) {
      InterfaceClass.implementClass(classDef);
    });
    return classDef;
  };
}

function makeContainer(config) {
  var container = new BrowserContainer(config);
  return makeContainerApi(container);
}

function requireFile() {
  throw new Error('The method requireContext is only for implemented node, in webpack use require api');
}

function requireContext() {
  throw new Error('The method requireContext is only for implemented node, in webpack use require.context api');
}

function dependency(dep) {
  return new Dependency(dep);
}

makeContainer.dependency = dependency;
makeContainer.context = requireContext;
makeContainer.require = requireFile;
makeContainer.setInterfacePrototypeDefault = Container.setInterfacePrototypeDefault;
makeContainer.getInterfacePrototypeDefault = Container.getInterfacePrototypeDefault;

var BrowserContainer =
/*#__PURE__*/
function (_Container) {
  inherits(BrowserContainer, _Container);

  function BrowserContainer() {
    classCallCheck(this, BrowserContainer);

    return possibleConstructorReturn(this, getPrototypeOf(BrowserContainer).apply(this, arguments));
  }

  createClass(BrowserContainer, [{
    key: "depExists",
    value: function depExists(requirePath) {
      return !!this.getRequire(requirePath);
    }
  }, {
    key: "depRequire",
    value: function depRequire(requirePath) {
      return this.getRequire(requirePath);
    }
  }, {
    key: "require",
    value: function require(dep) {
      return new BrowserRequire(dep, this.requires);
    }
  }]);

  return BrowserContainer;
}(Container);

exports.default = makeContainer;
exports.InterfaceClass = InterfaceClass$1;
exports.InterfacePrototype = InterfacePrototype;
exports.Interface = Interface$1;
exports.instanceOf = instanceOf;
//# sourceMappingURL=browser.js.map
